/* rexx macro */

options results                             /* enable return codes     */

if (left(address(), 6) ~= "GOLDED") then    /* not started by GoldEd ? */

    address 'GOLDED.1'

'LOCK CURRENT RELEASE=4'                    /* lock GUI, gain access   */

if (RC ~= 0) then

    exit

options failat 6                            /* ignore warnings         */

signal on syntax                            /* ensure clean exit       */

/* ------------------------- INSERT YOUR CODE HERE: ------------------ */

/* INPUTS: CMODE/K (supported values for CMODE: SAS-C,VBCC,GCC,STORMC,GENERIC) */

parse upper arg CMODE .

'QUERY CAT'

if (RESULT = "deutsch") then do

    STRING.sSYNTAX       = "Erforderliches Argument fehlt: CMODE/K"
    STRING.sNOTINSTALLED = "Support fr diesen Compiler wurde nicht|installiert:"
end
else do

    STRING.sSYNTAX       = "Required argument missing: CMODE/K"
    STRING.sNOTINSTALLED = "Support fr this compiler has not been|installed:"
end

if (CMODE = "") then

    'REQUEST PROBLEM="' || STRING.sSYNTAX || '"'

else if (exists("golded:add-ons/c++/compilers/" || CMODE)) then do

    if (CMODE = "SAS-C") then

        FILETYPE = "SAS/C#?"

    else if (CMODE = "VBCC") then

        FILETYPE = "vbcc#?"

    else if (CMODE = "GCC") then

        FILETYPE = "gcc#?"

    else if (CMODE = "STORMC") then

        FILETYPE= "StormC#?"
    else
        FILETYPE = "C/C++#?"

    /* sort compiler-specific filetype to top */

    'TYPE SORT="' || FILETYPE || '"'
end
else
    'REQUEST PROBLEM="' || STRING.sNOTINSTALLED || " " || CMODE || '"'

/* ---------------------------- END OF YOUR CODE ----------------------- */

'UNLOCK' /* VERY important: unlock GUI */

exit

SYNTAX:

SAY "Sorry, error line" SIGL ":" ERRORTEXT(RC) ":-("

'UNLOCK'

exit
